glibmm: Gio::UnixFDMessage Class Reference

glibmm 2.36.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::UnixFDMessage Class Reference
Portable Network I/O Functionality

UnixFDMessage — A GSocketControlMessage containing a GUnixFDList. More...

`#include <giomm/unixfdmessage.h>`

Inheritance diagram for Gio::UnixFDMessage:
[legend]

## Public Member Functions
virtual | ~UnixFDMessage ()
GUnixFDMessage* | gobj ()
| Provides access to the underlying C GObject.
const GUnixFDMessage* | gobj () const
| Provides access to the underlying C GObject.
GUnixFDMessage* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< UnixFDList > | get_fd_list ()
| Gets the UnixFDList contained in message.
Glib::RefPtr< const UnixFDList > | get_fd_list () const
| Gets the UnixFDList contained in message.
bool | append_fd (int fd)
| Adds a file descriptor to message.
Glib::ArrayHandle< int > | steal_fds ()
| Returns the array of file descriptors that is contained in this object.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< UnixFDList > > | property_fd_list () const
| The GUnixFDList object to send with the message.
Public Member Functions inherited from Gio::SocketControlMessage
virtual | ~SocketControlMessage ()
int | get_level () const
| Returns the "level" (i.e. the originating protocol) of the control message.
int | get_msg_type () const
| Returns the protocol specific type of the control message.
gsize | get_size () const
| Returns the space required for the control message, not including headers or alignment.
void | serialize (gpointer data)
| Converts the data in the message to bytes placed in the message.
virtual gsize | get_size_vfunc () const
virtual int | get_level_vfunc () const
virtual int | get_type_vfunc () const
virtual void | serialize_vfunc (gpointer data)
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable ()
| trackable (const trackable &src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr < UnixFDMessage > | create ()
| Creates a new UnixFDMessage containing an empty file descriptor list.
static Glib::RefPtr < UnixFDMessage > | create (const Glib::RefPtr< UnixFDList >& fd_list)
| Creates a new UnixFDMessage containing list.
Static Public Member Functions inherited from Gio::SocketControlMessage
static Glib::RefPtr < SocketControlMessage > | deserialize (int level, int type, gsize size, gpointer data)
| Tries to deserialize a socket control message of a given level and type.

## Protected Member Functions
| UnixFDMessage ()
| UnixFDMessage (const Glib::RefPtr< UnixFDList >& fd_list)
Protected Member Functions inherited from Gio::SocketControlMessage
| SocketControlMessage ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixFDMessage > | wrap (GUnixFDMessage* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::SocketControlMessage
Glib::RefPtr < Gio::SocketControlMessage > | wrap (GSocketControlMessage* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

UnixFDMessage — A GSocketControlMessage containing a GUnixFDList.

This SocketControlMessage contains a UnixFDList. It may be sent using Gio::Socket::send() and received using Gio::Socket::receive() over UNIX sockets (ie: sockets in the Gio::SOCKET_ADDRESS_UNIX family). The file descriptors are copied between processes by the kernel.

For an easier way to send and receive file descriptors over stream-oriented UNIX sockets, see Gio::UnixConnection::send_fd() and Gio::UnixConnection::receive_fd().

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::UnixFDMessage::~UnixFDMessage | ( |  | ) |
| virtual

Gio::UnixFDMessage::UnixFDMessage | ( |  | ) |
| protected

Gio::UnixFDMessage::UnixFDMessage | ( | const Glib::RefPtr< UnixFDList >& | fd_list | ) |
| explicitprotected

## Member Function Documentation

bool Gio::UnixFDMessage::append_fd | ( | int | fd | ) |

Adds a file descriptor to message.

The file descriptor is duplicated using dup(). You keep your copy of the descriptor and the copy contained in message will be closed when message is finalized.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

Since glibmm 2.22:

Parameters

  fd | A valid open file descriptor.

Returns
  `true` in case of success, else `false` (and error is set).

static Glib::RefPtr<UnixFDMessage> Gio::UnixFDMessage::create | ( |  | ) |
| static

Creates a new UnixFDMessage containing an empty file descriptor list.

Since glibmm 2.22:

Returns
  A new UnixFDMessage.

static Glib::RefPtr<UnixFDMessage> Gio::UnixFDMessage::create | ( | const Glib::RefPtr< UnixFDList >& | fd_list | ) |
| static

Creates a new UnixFDMessage containing list.

Since glibmm 2.24:

Parameters

  fd_list | A UnixFDList.

Returns
  A new UnixFDMessage.

Glib::RefPtr<UnixFDList> Gio::UnixFDMessage::get_fd_list | ( |  | ) |

Gets the UnixFDList contained in message.

This function does not return a reference to the caller, but the returned list is valid for the lifetime of message.

Since glibmm 2.24:

Returns
  The UnixFDList from message.

Glib::RefPtr<const UnixFDList> Gio::UnixFDMessage::get_fd_list | ( |  | ) | const

Gets the UnixFDList contained in message.

This function does not return a reference to the caller, but the returned list is valid for the lifetime of message.

Since glibmm 2.24:

Returns
  The UnixFDList from message.

static GType Gio::UnixFDMessage::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Reimplemented from Gio::SocketControlMessage.

GUnixFDMessage* Gio::UnixFDMessage::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketControlMessage.

const GUnixFDMessage* Gio::UnixFDMessage::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketControlMessage.

GUnixFDMessage* Gio::UnixFDMessage::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::SocketControlMessage.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<UnixFDList> > Gio::UnixFDMessage::property_fd_list | ( |  | ) | const

The GUnixFDList object to send with the message.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::ArrayHandle<int> Gio::UnixFDMessage::steal_fds | ( |  | ) |

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors are no longer contained in message. Further calls will return an empty list (unless more descriptors have been added).

The caller is responsible for closing all of the file descriptors.

Returns
  An array of file descriptors.

Since glibmm 2.28:

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixFDMessage > wrap | ( | GUnixFDMessage * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.